Subject: Re: bug#51309: 28.0.60; [Feature Request] Allow to customize tab-bar button images

From: Juri Linkov <[email-masked]>
Date: Thu, 21 Oct 2021 19:46:13 +0300

> as you can see in the attached images, the xpm files provided for
> tab-bar buttons don't look very well in many cases:
>
> 1. They are low resolution so they are scaled x 2 in HiDPI screens
> (when there is support for this, I guess for other users they look
> tiny instead).
> 2. The light background is particularly ugly (at least IMO) with dark
> themes and, in general, I believe the ability to blend the button
> background with the default background would be appreciated by a
> number of users.
> 3. Vertical alignment looks slightly off center.

They look sufficiently well but there is always room for improvement.
All suggestions are welcome.

> Maybe "tabs/close.xpm" is already intended to be an abstract
> specification of an xpm that is then loaded as described in [1]:
>
>> If file is not an absolute file name, it is expanded relative to the
>> images subdirectory of data-directory
>
> so that each theme has to locally, temporally(, whatever) override
> data-directory somehow, but I believe it's not like that, I believe
> icons are simply hardcoded.
>
> Given the shortcomings listed above, why not provide some customizable
> variables to change the icons?

This definitely should be customizable, but it's unclear what do you
want to customize: only the file path to the image, or allow to set
the button propertized with an image with image properties like
:margin/:ascent?

Could you send such a button string with an image that looks good
on HiDPI screens?  Then we could try to make a customizable option
based on your design.